<%inherit file="base.html" />
<%!
    import lazylibrarian
%>
<%def name="headerIncludes()">
  <div id="subhead_container" class="row">
    <form id="subhead_menu" class="form-inline">
      <div class="col-xs-10">
        %if perm&lazylibrarian.perm_force:
        <a id="forcesearch" class="btn btn-sm btn-primary" href="forceSearch?source=books"><i class="fa fa-search"></i> Search</a>
        <a id="forcepostprocess" class="btn btn-sm btn-primary" href="forceProcess?source=books"><i class="fa fa-cogs"></i> Run Post-Processor</a>
        <a href="libraryScan?library=eBook" class="btn btn-sm btn-primary" id="scan"><i class="fa fa-bolt"></i> Library Scan</a>
        %endif
        <a href="bookWall?have=0" class="button btn btn-sm btn-primary"><i class="fa fa-calendar-plus"></i> Additions</a>
        <a href="bookWall?have=1" class="button btn btn-sm btn-primary"><i class="fa fa-calendar-alt"></i> Downloads</a>
        %if lazylibrarian.CONFIG['USER_ACCOUNTS'] == True:
          %if lazylibrarian.CONFIG['RSS_ENABLED'] == True:
            <a href="rssFeed?user=${user}&type=eBook&limit=10.xml" class="button btn btn-sm btn-primary" data-toggle="tooltip" title="RSS feed of recent downloads"><i class="fa fa-rss"></i></a>
            <link rel="alternate" type="application/rss+xml" title="LazyLibrarian latest eBooks" href="rssFeed?user=${user}&type=eBook&limit=10.xml">
          %endif
          %if pref&lazylibrarian.pref_myfeeds:
            <a href="toggleMyFeeds" class="button btn btn-sm btn-primary" data-toggle="tooltip" title="All, or just mine"><i class="fa fa-user-circle"></i></a>
          %else:
            <a href="toggleMyFeeds" class="button btn btn-sm btn-primary" data-toggle="tooltip" title="All, or just mine"><i class="fa fa-users"></i></a>
          %endif
        %endif
      </div>
        %if len(languages) > 1:
          <div class="form-group pull-right">
            <label for="chooselanguage"><small>Language</small></label>
            <select class="form-control input-sm" name="chooselanguage" id="chooselanguage">
            <option value="">All</option>
            %for language in languages:
            <option value="${language['BookLang']}">${language['BookLang']}</option>
            %endfor
            </select>
          </div>
        %endif
    </form>
  </div>
</%def>
<%def name="body()">
  <h1>${title}</h1>
  %if lazylibrarian.EBOOK_UPDATE == True:
    <p>
    <button onclick="" id="myAlert" title=""><i class="fa fa-circle-notch fa-spin"></i> Libraryscan in progress ...</button>
    </p>
  %endif
  <form name="markBooks" id="markBooks" action="markBooks" method="get" class="form-inline" onsubmit="return false;">
    <div class="row">
      <input type="hidden" name="booklang" value=${booklang}>
      <input type="hidden" name="redirect" value='books'>
      %if perm&lazylibrarian.perm_status or lazylibrarian.CONFIG['USER_ACCOUNTS']:
      <div class="col-xs-12 col-sm-5">
        <div class="form-group">
          <label for="markBooks" class="control-label">Mark selected as</label>
          <select class="markBooks form-control input-sm" id="action" name="action">
          %if perm&lazylibrarian.perm_status:
            <option value="Wanted">Wanted</option>
            <option value="Have">Have</option>
            <option value="Ignored">Ignored</option>
            <option value="Skipped">Skipped</option>
            <option value="Remove">Remove</option>
            <option value="Delete">Delete</option>
          %endif
            %if lazylibrarian.CONFIG['USER_ACCOUNTS']:
              <option value="Unread">Unread</option>
              <option value="Read">Read</option>
              <option value="ToRead">To Read</option>
              <option value="Reading">Reading</option>
              <option value="Abandoned">Abandoned</option>
            %endif
          </select>
        </div>
        <button type="submit" class="btn btn-sm btn-primary" onclick="validateForm()">Go</button>
      </div>
      %endif
      %if lazylibrarian.CONFIG['TOGGLES'] == True:
        <div class="toggles col-xs-12 col-sm-7 text-right">
          Toggle: <a class="toggle-vis" data-column="1"> Cover</a>
          <a class="toggle-vis" data-column="2"> Author</a>
          <a class="toggle-vis" data-column="3"> Title</a>
          <a class="toggle-vis" data-column="4"> Series</a>
          <a class="toggle-vis hidden-sm hidden-xs" data-column="5"> Rating</a>
          <a class="toggle-vis" data-column="6"> Released</a>
          <a class="toggle-vis" data-column="7"> Added</a>
          <a class="toggle-vis" data-column="8"> Status</a>
        </div>
      %endif
    </div>
    <br/>
    <div class="table-responsive">
      <table class="display table table-striped table-hover table-bordered" id="book_table">
        <thead>
          <tr>
            %if perm&lazylibrarian.perm_status:
            <th class="select text-center no-sort"><input type="checkbox" onClick="toggleAll(this)" /></th>
            %else:
            <th class="hidden"></th>
            %endif
            <th class="bookart text-center no-sort">Cover</th>
            <th class="authorname">Author</th>
            <th class="bookname">Title</th>
            <th class="series">Series</th>
            <th class="stars text-center hidden-sm hidden-xs">Rating</th>
            <th class="date text-center">Released</th>
            <th class="date text-center">Added</th>
            <th class="status text-center">Status</th>
          </tr>
        </thead>
      </table>
    </div>
  </form>
</%def>
<%def name="javascriptIncludes()">
  <script type="text/javascript">

        $(document).ready(function() {

        var selected = [];

        $('#chooselanguage').change(function(){
            window.location = 'books?BookLang=' + $(this).val()
        })
        $('#chooselanguage').val(getUrlVars()['BookLang']);

        var show = ""+${lazylibrarian.CONFIG['BOOK_IMG']};
            if ( show != '1' ) { showimg = false }
            else { showimg = true }

        var table = $('#book_table').DataTable({
            "dom": "<'row'<'col-xs-6'l><'col-xs-6'f>><'row'<'col-sm-12'tr>><'row'<'col-sm-5'i><'col-sm-7'p>>",
            "bAutoWidth": false,
            "stateSave": true,
            "order": [[ 2, 'asc' ]],
            "rowId": 0,
            "columnDefs":[
                { targets: 'no-sort', orderable: false },
                { targets: [0],
                  'class': 'text-center',
                  'render': function(data, type, row) {
                    if ( $.inArray('B' + data, selected) !== -1 ) {
                        return '<input type="checkbox" id="B' + data + '" name="' + data + '" class="checkbox" checked=true />'; }
                    return '<input type="checkbox" id="B' + data + '" name="' + data + '" class="checkbox" />';} },
                { targets: [1],
                    'visible': showimg,
                    'render': function(data, type, row) {
                    return '<a href="' + data + '" target="_blank" rel="noreferrer"><img src="' + data + '" alt="Cover" class="bookcover-sm img-responsive"></a>';} },
                { targets: [2], 'render': function(data, type, row) {
                  %if perm&lazylibrarian.perm_authorbooks:
                    btn = '<a href=\'authorPage?AuthorID=' + row[8] + '\'">' + data + '</a>'
                  %else:
                    btn = '<a>' + data + '</a>'
                  %endif
                 return btn ;}
                },
                { targets: [3], 'render': function(data, type, row) {
                    var pre = data.split('<');
                    var limit = window.innerWidth / 30;
                    var title = truncateOnWord(pre[0], limit);
                    var tail = data.slice(pre[0].length);
                    btn = '<button onclick="bookinfo(\'' + row[9] + '\')" class="button btn-link text-left" type="button" '
                    if (title == pre[0]) { return btn + '>' + title + '</button>' + tail ; }
                    return btn + ' title="' + pre[0] + '">' + title + '</button>' + tail ;
                    }
                },
                { targets: [4], 'render': function(data, type, row){
                    if (row[12] === null ) { return data; }
                    if (row[12] === '' ) { return row[4]; }
                    var series = row[12].split('^');
                    var output = [];
                    for (var index=0; index < series.length; ++index) {
                        var link_data = series[index].split("~");
                        output.push('<a href=seriesMembers?seriesid=' + link_data[0] + '>' + link_data[1] + '</a>')
                    }
                    return output.join('<br>');
                }},
                %if lazylibrarian.CONFIG['RATESTARS'] == True:
                { targets: [5],
                    'class': 'text-center',
                    'render': function(data, type, row) {
                        return '<img src="images/' + data + '-stars.png" alt="Rating">';} },
                %endif
                { targets: [6],
                    'class': "text-center",
                    'render': function(data, type, row) {
                        return '<a data-toggle="tooltip" title="Listed: ' + row[14] + '\n' + row[15] + '">' + row[6] + '</a>';} },
                { targets: [7],
                    'class': 'text-center',
                    'render': function(data, type, row) {
                    var str = row[10];
                    if (str === "null"){ str = ""}
                    return str ;} },
                { targets: [8],
                    'class': 'text-center',
                    'render': function(data, type, row) {
                    var btn = row[11];
                    var flag = row[13]
                    btn = btn + flag
                    if ( btn.indexOf('Open') >= 0 ) {
                        btn = '<a class="button green btn btn-xs btn-warning" href="openBook?bookid=' + row[9] +
                            '&library=eBook" target="_self"><i class="fa fa-book"></i> ' + btn + '</a>'
                        %if len(email):
                            btn += '<a class="button green btn btn-xs btn-info" href="sendBook?bookid=' + row[9] +
                                '&library=eBook" target="_self">Send</a>'
                        %endif
                    }
                    else if ( btn.indexOf('Wanted') >= 0 ) {
                        %if perm&lazylibrarian.perm_force:
                            btn = '<p><a class="a btn btn-xs btn-danger">' + btn + '</a></p><p><a class="b btn btn-xs btn-success" href="searchForBook?bookid=' + row[9] + '&library=eBook" target="_self"><i class="fa fa-search"></i> Search</a></p>'
                        %else:
                            btn = '<p><a class="button btn btn-xs btn-default grey" href="requestBook?bookid=' + row[9] + '&library=eBook" target="_self">Request</a></p>'
                        %endif
                    }
                    else if ( btn.indexOf('Snatched') >= 0 ) {
                        btn = '<a class="button btn btn-xs btn-info">Snatched</a>'}
                    else if ( btn.indexOf('Have') >= 0 ) {
                        %if perm&lazylibrarian.perm_status:
                            btn = '<a class="button btn btn-xs btn-info">' + btn + '</a>'
                        %else:
                          btn = '<p><a class="button btn btn-xs btn-default grey" href="requestBook?bookid=' + row[9] + '&library=eBook" target="_self">Request</a></p>'
                        %endif
                        }
                    else {
                        %if perm&lazylibrarian.perm_status:
                        btn = '<a class="button btn btn-xs btn-default grey">' + btn + '</a>'
                        %else:
                        btn = '<p><a class="button btn btn-xs btn-default grey" href="requestBook?bookid=' + row[9] + '&library=eBook" target="_self">Request</a></p>'
                        %endif
                        }
                    return btn;} }
                ],
            "oLanguage": {
                "sSearch": "Filter: ",
                "sLengthMenu":"_MENU_ rows per page",
                "sEmptyTable": "No books found",
                "sInfo":"Showing _START_ to _END_ of _TOTAL_ rows",
                "sInfoEmpty":"Showing 0 to 0 of 0 rows",
                "sInfoFiltered":"(filtered from _MAX_ total rows)"},

            "aLengthMenu": [[5, 10, 15, 25, 50, 100, -1], [5, 10, 15, 25, 50, 100, "All"]],
            "iDisplayLength": ${lazylibrarian.CONFIG['DISPLAYLENGTH']},
            "sPaginationType": "full_numbers",
            "aaSorting": [[0, 'asc']],
            "bServerSide": true,
            "sAjaxSource": 'getBooks?source=Books&booklang=${booklang}',
            "bFilter": true,
            "fnRowCallback": function (nRow, aData, iDisplayIndex, iDisplayIndexFull) {
                %if perm&lazylibrarian.perm_status == 0:
                  $('td', nRow).eq(0).addClass("hidden");
                %endif
                // hide cover,stars,date on small devices
                //$('td', nRow).eq(1).addClass('hidden-xs');
                $('td', nRow).eq(5).addClass('hidden-sm hidden-xs');
                //$('td', nRow).eq(6).addClass('hidden-xs');
                //$('td', nRow).eq(7).addClass('hidden-xs');
                return nRow;
            },
        });

          $('#book_table tbody').on('click', 'tr input:checkbox', function () {
              var id = this.id;
              var index = $.inArray(id, selected);
              if ( index === -1 ) {
                  selected.push( id );
              } else {
                  selected.splice( index, 1 );
              }
              $(this).toggleClass('selected');
          } );

            table.on( 'xhr', function () {
              var json = table.ajax.json();
              if (json.loading) {
                setInterval( function () {
              table.ajax.reload( null, false );
            }, 10000 );
              }
              else {
                $('#myAlert').addClass('hidden');
              };
            });

        $('.dataTables_filter input').attr("placeholder", "Results filter");
        //$(window).resize(function() {table.draw('page')});

        $('a.toggle-vis').click(function (e) {
            e.preventDefault();
            var column = table.column( $(this).attr('data-column') );
            column.visible( ! column.visible() );
        } );
        //enable datatables console logging
        //table.on(function ( e ) {
        //   console.log( e ); } );
    });

    function validateForm() {
        var x = document.forms["markBooks"]["action"].value;
        var c = (document.querySelectorAll('input[class="checkbox"]:checked').length);
        if (c > 0 && x == "Delete") {
            if (c == 1) {msg = "Are you sure you want to permanently delete the selected book?"}
            if (c > 1) {msg = "Are you sure you want to permanently delete the " + c + " selected books?"}
            bootbox.confirm({
                message: msg,
                buttons: {
                    confirm: {
                        label: 'Yes',
                        className: 'btn-success'
                    },
                    cancel: {
                        label: 'No',
                        className: 'btn-danger'
                    }
                },
                callback: function (result) {
                    if (result) { document.getElementById("markBooks").submit(); }
                }
            });
            return false;
        }
        else { document.getElementById("markBooks").submit(); }
    }

  </script>
</%def>
